package com.mx.cneeds.server.device.web;

import com.mx.cneeds.common.dto.DeviceChannelDto;
import com.mx.cneeds.common.dto.SeriesDto;
import com.mx.cneeds.common.pager.PageUtils;
import com.mx.cneeds.common.result.R;
import com.mx.cneeds.common.validator.ValidatorUtils;
import com.mx.cneeds.server.device.service.DeviceChannelService;
import com.mx.cneeds.server.device.service.DeviceInfoChannelService;
import com.mx.cneeds.server.entity.DeviceChannelEntity;
import com.mx.cneeds.server.entity.DeviceInfoEntity;
import com.mx.cneeds.server.entity.ProductSeriesEntity;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @ClassName DeviceChannelController
 * @Author zzrdark
 * @Date 2020-05-11 17:51
 * @Description TODO
 **/

@RestController
@RequestMapping("/devicechannel")
public class DeviceChannelController {

    @Autowired
    private DeviceChannelService deviceChannelService;

    @Autowired
    private DeviceInfoChannelService deviceInfoChannelService;


    /**
     * 列表
     */
    @RequestMapping("/list")
    public PageUtils list(@RequestParam Map<String, Object> params){
        PageUtils page = deviceChannelService.queryPage(params);
        List<SeriesDto> list = new ArrayList<SeriesDto>();
        for (Object entity : page.getList()){
            SeriesDto dto = new SeriesDto();
            ProductSeriesEntity seriesEntity = (ProductSeriesEntity) entity;
            BeanUtils.copyProperties(seriesEntity,dto);
            list.add(dto);
        }
        return page;
    }


    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody DeviceChannelDto deviceChannelDto){
        DeviceChannelEntity deviceChannelEntity = new DeviceChannelEntity();
        BeanUtils.copyProperties(deviceChannelDto,deviceChannelEntity);

        deviceChannelService.save(deviceChannelEntity);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody DeviceChannelDto deviceChannelDto){
        ValidatorUtils.validateEntity(deviceChannelDto);
        DeviceChannelEntity deviceChannelEntity = new DeviceChannelEntity();
        BeanUtils.copyProperties(deviceChannelDto,deviceChannelEntity);
        deviceChannelService.updateById(deviceChannelEntity);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Long[] deviceIds){
        deviceChannelService.removeByIds(Arrays.asList(deviceIds));

        return R.ok();
    }
}
